// AriesDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "Aries.h"
#include "AriesDlg.h"
#include "ZerosEncodeSource.h"
#include "FileEncodeSource.h"
#include "NullDevEncodeDestination.h"
#include "PatternEncodeSource.h"
#include "Encoder.h"
#include "MathEncodeObserver.h"
#include "StepViewer.h"
#include <assert.h>
#include "AritStep.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAriesDlg Dialogfeld

CAriesDlg::CAriesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAriesDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAriesDlg)
	m_filename = _T("");
	m_pattern = _T("");
	m_patternNum = 0;
	m_zeroNum = 0;
	m_dstSymbolCount = _T("");
	m_srcSymbolCount = _T("");
	m_dstRedundancy = _T("");
	m_dstZeroNum = _T("");
	m_srcEntropy = _T("");
	m_srcRedundancy = _T("");
	m_srcZeroNum = _T("");
	m_dstEntropy = _T("");
	m_lblRate = _T("");
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	currentDataSource = nothing;
	m_encoder = NULL;

	//open splash screen
	CAboutDlg about;
	about.DoModal();

}

void CAriesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAriesDlg)
	DDX_Control(pDX, IDC_RADIOGROUP, m_radioGroup);
	DDX_Control(pDX, IDC_CBOMODEL, m_cboModel);
	DDX_Control(pDX, IDC_BTNGRAPH, m_btnGraph);
	DDX_Control(pDX, IDC_BTNCODE, m_btnCode);
	DDX_Text(pDX, IDC_EDTFILENAME, m_filename);
	DDX_Text(pDX, IDC_EDTPATTERN, m_pattern);
	DDX_Text(pDX, IDC_EDTPATTERNNUM, m_patternNum);
	DDV_MinMaxUInt(pDX, m_patternNum, 1, 1000);
	DDX_Text(pDX, IDC_EDTZERONUM, m_zeroNum);
	DDV_MinMaxUInt(pDX, m_zeroNum, 1, 32766);
	DDX_Text(pDX, IDC_LBLDSTSYMBOLNUM, m_dstSymbolCount);
	DDX_Text(pDX, IDC_LBLSRCSYMBOLNUM, m_srcSymbolCount);
	DDX_Text(pDX, IDC_LBLDSTREDUNDANCY, m_dstRedundancy);
	DDX_Text(pDX, IDC_LBLDSTZERONUM, m_dstZeroNum);
	DDX_Text(pDX, IDC_LBLSRCENTROPY, m_srcEntropy);
	DDX_Text(pDX, IDC_LBLSRCREDUNDANCY, m_srcRedundancy);
	DDX_Text(pDX, IDC_LBLSRCZERONUM, m_srcZeroNum);
	DDX_Text(pDX, IDC_LBLDSTENTROPY, m_dstEntropy);
	DDX_Text(pDX, IDC_LBLRATE, m_lblRate);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAriesDlg, CDialog)
	//{{AFX_MSG_MAP(CAriesDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON2, OnStartCoding)
	ON_BN_CLICKED(IDC_BUTTON1, OnBrowse)
	ON_BN_CLICKED(IDC_RDOFILE, OnRdofile)
	ON_BN_CLICKED(IDC_RDOPATTERN, OnRdopattern)
	ON_BN_CLICKED(IDC_RDOZEROS, OnRdozeros)
	ON_BN_CLICKED(IDC_BUTTON3, OnGraphic)
	ON_BN_CLICKED(IDC_EXITBUTTON, OnExitbutton)
	ON_EN_CHANGE(IDC_EDTFILENAME, OnChangeEdtfilename)
	ON_EN_CHANGE(IDC_EDTZERONUM, OnChangeEdtzeronum)
	ON_EN_CHANGE(IDC_EDTPATTERN, OnChangeEdtpattern)
	ON_EN_CHANGE(IDC_EDTPATTERNNUM, OnChangeEdtpatternnum)
	ON_CBN_DROPDOWN(IDC_CBOMODEL, OnDropdownCbomodel)
	ON_BN_CLICKED(IDC_BTNCODE, OnStartCoding)
	ON_BN_CLICKED(IDC_BTNBROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAriesDlg Nachrichten-Handler

BOOL CAriesDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen

	m_patternNum = 1;
	m_zeroNum = 1;
	m_srcSymbolCount = "0 Byte";
	m_srcZeroNum = "0 Byte";
	m_srcEntropy = "0 bit/Byte";
	m_srcRedundancy = "0 bit/Byte";
	m_dstSymbolCount = "0 Byte";
	m_dstZeroNum = "0 Byte";
	m_dstEntropy = "0 bit/Byte";
	m_dstRedundancy = "0 bit/Byte";
	m_cboModel.SetCurSel(0);

	SetDefID(IDC_BTNCODE); //encode is the default button

	disableCoding();
		
	UpdateData(FALSE);

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CAriesDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CAriesDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CAriesDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CAriesDlg::OnStartCoding() 
{
	
	BeginWaitCursor();
	if(m_encoder!=NULL)
		delete m_encoder;
	m_encoder = new CEncoder();

	CEncodeSource* src=NULL;
	CNullDevEncodeDestination dst;
	CMathEncodeObserver obs;

	if(!UpdateData(TRUE)){
		EndWaitCursor();
		return;
	}

	switch(currentDataSource){
	case file:{
		CFileEncodeSource* s = new CFileEncodeSource();
		s->setFilename(m_filename);
		src = s;
		break;
			  }
	case zeros:{
		CZerosEncodeSource* s = new CZerosEncodeSource();
		s->setBytesToProduce (m_zeroNum);
		src = s;
		break;
			   }
	case pattern:{
		CPatternEncodeSource* s = new CPatternEncodeSource();
		s->setPattern(m_pattern,m_patternNum);
		src=s;
		break;
				}
	case nothing:
		return;
			   
	default:
		assert(0);

	}


		
	if(!src->open()){
		delete src;
		disableCoding();
		EndWaitCursor();
		return;

	}
	m_encoder->setEncodeSource(src);

	if(!dst.open()){
		delete src;
		disableCoding();
		EndWaitCursor();
		return;

	}
	m_encoder->setEncodeDestination (&dst);

	m_encoder->removeAllEncodeObservers();
	m_encoder->addEncodeObserver(&obs);

	CString model;
	m_cboModel.GetLBText(m_cboModel.GetCurSel(),model);
	if(model=="Adaptiv")
		m_encoder->setIsAdaptiveModel(true);
	 else m_encoder->setIsAdaptiveModel(false);
	m_encoder->encode();

	src->close();
	dst.close();


	if(src!=NULL)
		delete src;





	m_srcSymbolCount.Format("%d Byte",obs.m_srcData.symbolCount);
	m_dstSymbolCount.Format("%d Byte",obs.m_dstData.symbolCount);

	m_srcZeroNum.Format("%d Byte",obs.m_srcData.zeroCount);
	m_dstZeroNum.Format("%d Byte",obs.m_dstData.zeroCount);

	m_srcEntropy.Format("%.2f bit/Byte",obs.m_srcData.entropie);
	m_dstEntropy.Format("%.2f bit/Byte",obs.m_dstData.entropie);

	m_srcRedundancy.Format("%.2f bit/Byte",obs.m_srcData.redundanz);
	m_dstRedundancy.Format("%.2f bit/Byte",obs.m_dstData.redundanz);

	m_lblRate.Format("Reduktion um %.2f%%",100.0-(100.0*(float)obs.m_dstData.symbolCount/(float)obs.m_srcData.symbolCount));

	m_btnGraph.EnableWindow(true);
	
	UpdateData(FALSE);
	EndWaitCursor();

}


void CAriesDlg::OnBrowse() 
{
	CFileDialog d(true);
	d.DoModal();

	m_filename = d.GetPathName();
	currentDataSource = file;	
	enableCoding();

	setRadioButton(IDC_RDOFILE);
	
	UpdateData(FALSE);

}

void CAriesDlg::OnRdofile() 
{
	currentDataSource = file;	
	enableCoding();
}

void CAriesDlg::OnRdopattern() 
{
	currentDataSource = pattern;	
	enableCoding();
}

void CAriesDlg::OnRdozeros() 
{
	currentDataSource = zeros;	
	enableCoding();
}

void CAriesDlg::updateGUI()
{

}

void CAriesDlg::OnGraphic() 
{
	//return if nothing was already encoded
	if(m_encoder==NULL)
		return;

	CStepViewer dlg(this);
	dlg.setSteps(m_encoder->getSteps());
	dlg.DoModal();
}


void CAriesDlg::CalcWindowRect(LPRECT lpClientRect, UINT nAdjustType) 
{
	// TODO: Speziellen Code hier einfgen und/oder Basisklasse aufrufen
	
	CDialog::CalcWindowRect(lpClientRect, nAdjustType);
	//delete m_dlgStepView;
}

CAriesDlg::~CAriesDlg()
{
	if(m_encoder!=NULL)
		delete m_encoder;
	CDialog::~CDialog();
}

void CAriesDlg::OnExitbutton() 
{
	EndDialog(IDOK);
}

void CAriesDlg::disableCoding()
{
	m_btnCode.EnableWindow(false);
	m_btnGraph.EnableWindow(false);
}


void CAriesDlg::enableCoding()
{
	m_btnCode.EnableWindow(true);

	m_btnGraph.EnableWindow(false);
}

void CAriesDlg::OnChangeEdtfilename() 
{
	UpdateData(TRUE);
	if(m_filename!=""){
		setRadioButton(IDC_RDOFILE);
		enableCoding();	
	}else disableCoding();
}


void CAriesDlg::setRadioButton(int id)
{
	CButton* rdo = NULL;
	const int radioIDs[] = {IDC_RDOFILE,IDC_RDOZEROS,IDC_RDOPATTERN};
	const Sources radioSrc[] ={file,zeros,pattern};

	//switch each radio button off, except the one with the id 'id'
	for(int i=0;i<3;i++){
		rdo	= static_cast<CButton*>(GetDlgItem(radioIDs[i]));
		if(radioIDs[i]==id){
			currentDataSource = radioSrc[i];
			rdo->SetCheck(true);
		} else rdo->SetCheck(false);
	}
}

void CAriesDlg::OnChangeEdtzeronum() 
{
	setRadioButton(IDC_RDOZEROS);
	enableCoding();
}

void CAriesDlg::OnChangeEdtpattern() 
{
	setRadioButton(IDC_RDOPATTERN);
	enableCoding();
}

void CAriesDlg::OnChangeEdtpatternnum() 
{
	setRadioButton(IDC_RDOPATTERN);
	enableCoding();
}


void CAriesDlg::OnDropdownCbomodel() 
{
	enableCoding();
}
