// AriesDlg.h : Header-Datei
//

#if !defined(AFX_ARIESDLG_H__9B34D775_136D_11D3_ADF9_00001C90247D__INCLUDED_)
#define AFX_ARIESDLG_H__9B34D775_136D_11D3_ADF9_00001C90247D__INCLUDED_

#include "Encoder.h"	// Hinzugefgt von der Klassenansicht
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "StepViewer.h"

/////////////////////////////////////////////////////////////////////////////
// CAriesDlg Dialogfeld

class CAriesDlg : public CDialog
{
// Konstruktion
public:
	virtual  ~CAriesDlg();
	CAriesDlg(CWnd* pParent = NULL);	// Standard-Konstruktor

// Dialogfelddaten
	//{{AFX_DATA(CAriesDlg)
	enum { IDD = IDD_ARIES_DIALOG };
	CButton	m_radioGroup;
	CComboBox	m_cboModel;
	CButton	m_btnGraph;
	CButton	m_btnCode;
	CString	m_filename;
	CString	m_pattern;
	UINT	m_patternNum;
	UINT	m_zeroNum;
	CString	m_dstSymbolCount;
	CString	m_srcSymbolCount;
	CString	m_dstRedundancy;
	CString	m_dstZeroNum;
	CString	m_srcEntropy;
	CString	m_srcRedundancy;
	CString	m_srcZeroNum;
	CString	m_dstEntropy;
	CString	m_lblRate;
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAriesDlg)
	public:
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	virtual void CalcWindowRect(LPRECT lpClientRect, UINT nAdjustType = adjustBorder);
	//}}AFX_VIRTUAL

private:
	void setRadioButton(int id);
	void enableCoding();
	void disableCoding();
	CEncoder* m_encoder;
	CStepViewer* m_dlgStepView;
	void updateGUI();
	enum Sources {file,pattern,zeros,nothing} currentDataSource;


// Implementierung
protected:
	HICON m_hIcon;

	// Generierte Message-Map-Funktionen
	//{{AFX_MSG(CAriesDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnStartCoding();
	afx_msg void OnBrowse();
	afx_msg void OnRdofile();
	afx_msg void OnRdopattern();
	afx_msg void OnRdozeros();
	afx_msg void OnGraphic();
	afx_msg void OnExitbutton();
	afx_msg void OnChangeEdtfilename();
	afx_msg void OnChangeEdtzeronum();
	afx_msg void OnChangeEdtpattern();
	afx_msg void OnChangeEdtpatternnum();
	afx_msg void OnDropdownCbomodel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_ARIESDLG_H__9B34D775_136D_11D3_ADF9_00001C90247D__INCLUDED_)
