// AritStep.cpp: Implementierung der Klasse CAritStep.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "stdafx.h"
#include "AritStep.h"
#include <assert.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CAritStep::CAritStep() : m_symbol(0), m_top(0), m_bottom(0), m_upper(0), m_lower(0)
{
	m_bitString = "";
}


CAritStep::~CAritStep()
{
}

CAritStep::CAritStep(const CString& data)
{
	const char TOK[] = ";";
	static tmpCount = 0;
	tmpCount ++;
	char *d = new char[data.GetLength()+1];
	char *stopString;
	strcpy (d,data);

	char *p=NULL;

	if(d[0]==';'){
		//empty m_bitString, don't strtok the data
		m_bitString = "";
	}else{
		p = strtok( d, TOK);
		assert(p);
		m_bitString = p;
	}


	p = strtok((p==NULL)?d:0, TOK);
	assert(p);
	m_bottom = strtod(p,&stopString);

	p = strtok( 0, TOK);
	assert(p);
	m_lower = strtod(p,&stopString);

	p = strtok( 0, TOK);
	assert(p);
	m_symbol = atoi(p);


	p = strtok( 0, TOK);
	assert(p);
	m_top = strtod(p,&stopString);

	p = strtok( 0, TOK);
	assert(p);
	m_upper = strtod(p,&stopString);

	p = strtok( 0, TOK);
	assert(p);
	m_relativeLower = strtod(p,&stopString);

	p = strtok( 0, TOK);
	assert(p);
	m_relativeUpper = strtod(p,&stopString);

	delete d;
}

void CAritStep::makeChildStep(CAritStep *step)
{
	step->setTop(m_upper);
	step->setBottom(m_lower);

	ProbValue range = step->getTop() - step->getBottom();
	ProbValue offset = step->getBottom();

	step->setLower(range*step->getLower()+offset);
	step->setUpper(range*step->getUpper()+offset);

}

void CAritStep::addBits(bool bit, int count)
{
	CString newStr(bit?'1':'0',count);
	m_bitString += newStr;
}


CString CAritStep::toString()
{

	CString buffer;

	buffer.Format("%s;%.15f;%.15f;%d;%.15f;%.15f;%.15f;%.15f",
			m_bitString,
			m_bottom,
			m_lower,
			m_symbol,
			m_top,
			m_upper,
			m_relativeLower,
			m_relativeUpper
		);
	
	return buffer;
}

