// AritStep.h: Schnittstelle fr die Klasse CAritStep.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ARITSTEP_H__FF70D8D3_1D86_11D3_9CA3_D2D3C4000000__INCLUDED_)
#define AFX_ARITSTEP_H__FF70D8D3_1D86_11D3_9CA3_D2D3C4000000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>
#include <list>
using namespace std ; //for the list


class CAritStep  
{
public:
	CAritStep();
	CAritStep(const CString& data);
	virtual ~CAritStep();

	typedef vector<CAritStep*> StepVector;
	typedef StepVector::iterator StepVectorIterator;

	typedef list<CAritStep*> StepList;
	typedef StepList::iterator StepListIterator;

private:
	typedef long double ProbValue;

	int m_symbol;

	ProbValue m_lower;
	ProbValue m_upper;
	ProbValue m_top;
	ProbValue m_bottom;
	ProbValue m_relativeLower;
	ProbValue m_relativeUpper;

	CString m_bitString;



public: //getter, setter methods
	int getSymbol(){return m_symbol;};
	void setSymbol(int v){m_symbol = v;};

	
	ProbValue getLower(){return m_lower;};
	void setLower(ProbValue v){m_lower = v;};
	ProbValue getUpper(){return m_upper;};
	void setUpper(ProbValue v){m_upper = v;};

	ProbValue getRelativeLower(){return m_relativeLower;};
	void setRelativeLower(ProbValue v){m_relativeLower = v;};
	ProbValue getRelativeUpper(){return m_relativeUpper;};
	void setRelativeUpper(ProbValue v){m_relativeUpper = v;};

	ProbValue getBottom(){return m_bottom;};
	void setBottom(ProbValue v){m_bottom = v;};
	ProbValue getTop(){return m_top;};
	void setTop(ProbValue v){m_top = v;};

	CString getBitString(){return m_bitString;};

public: 
	virtual CString toString();
	virtual void addBits(bool bit,int count);
	virtual void makeChildStep (CAritStep* step);
	
};

#endif // !defined(AFX_ARITSTEP_H__FF70D8D3_1D86_11D3_9CA3_D2D3C4000000__INCLUDED_)
