// Encoder.h: Schnittstelle fr die Klasse CEncoder.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ENCODER_H__0AF45D19_1786_11D3_9C95_A64108000000__INCLUDED_)
#define AFX_ENCODER_H__0AF45D19_1786_11D3_9C95_A64108000000__INCLUDED_

#include "EncodeSource.h"	// Hinzugefgt von der Klassenansicht
#include "EncodeDestination.h"
#include "EncodeObserver.h"
#include <list>
#include "AritStep.h"
#include "ariesstepview.h"	// Hinzugefgt von der Klassenansicht

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


using namespace std ; //for the list

static int *freq;
static void(*start_model)();
static void(*update_model)(int);

class CEncoder  
{
public:
	CEncoder();
	virtual ~CEncoder();

private:
	CAritStep::StepList m_steps;
	CEncodeDestination* m_encodeDestination;
	CEncodeSource *m_encodeSource;
	bool m_isAdaptiveModel;

	list<CEncodeObserver*> m_encodeObservers;
	//function classes, needed to 'for_each' the observers
	class ApplySources;
	class ApplyDestinations;

	//needed to delete the content of the StepVector
	class DeleteStep;

//getter and setter methods
public:
	virtual void setIsAdaptiveModel(bool s){m_isAdaptiveModel = s;}
	virtual bool getIsAdaptiveModel(){return m_isAdaptiveModel;}

	virtual void setEncodeSource(CEncodeSource* s){m_encodeSource = s;}
	virtual CEncodeSource* getEncodeSource(){return m_encodeSource;}

	virtual void setEncodeDestination(CEncodeDestination* s){m_encodeDestination = s;}
	virtual CEncodeDestination* getEncodeDestination(){return m_encodeDestination;}

	virtual CAritStep::StepList* getSteps(){return &m_steps;}


public:	
	virtual void removeAllSteps();
	virtual void addStep (CAritStep *step);
	virtual void applyDestinationObservers(int symbol);
	virtual void applySourceObservers(int symbol);
	virtual void removeAllEncodeObservers();
	virtual void addEncodeObserver(CEncodeObserver* obs);
	virtual void encode();

};

#endif // !defined(AFX_ENCODER_H__0AF45D19_1786_11D3_9C95_A64108000000__INCLUDED_)
