// MathEncodeObserver.cpp: Implementierung der Klasse CMathEncodeObserver.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "stdafx.h"
#include "MathEncodeObserver.h"
#include <math.h>
/* #include <stdio.h> */

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CMathEncodeObserver::CMathEncodeObserver()
{
	m_srcData.symbolCount = 0;
	m_dstData.symbolCount = 0;
	m_srcData.zeroCount = 0;
	m_dstData.zeroCount = 0;
	m_srcData.entropie = 0;
	m_dstData.entropie = 0;
	m_srcData.redundanz = 0;
	m_dstData.redundanz = 0;
	
	
	int i;
    for (i = 0; i<258; i++) {		
        m_srcData.specialSymbolCount[i]=0;			
		m_dstData.specialSymbolCount[i]=0;
	    m_srcData.specialSymbolProbability[i]=1;			
		m_dstData.specialSymbolProbability[i]=1;
		m_srcData.specialSymbolInformation[i]=0;			
		m_dstData.specialSymbolInformation[i]=0;
		m_srcData.specialSymbolEntropie[i]=0;			
		m_dstData.specialSymbolEntropie[i]=0;
	}
}

CMathEncodeObserver::~CMathEncodeObserver()
{

}

void CMathEncodeObserver::observeSource(int symbol)
{
	countSymbol(symbol,m_srcData);
}


void CMathEncodeObserver::observeDestination(int symbol)
{
	countSymbol(symbol,m_dstData);
}

void CMathEncodeObserver::countSymbol(int symbol, MathData &data)
{
#if 1
	data.symbolCount++;	
	if (symbol==0) data.zeroCount++;	/* Index 1 enspricht Symbol "0" */
	
	data.specialSymbolCount[symbol]++;

	data.entropie=0;
	data.redundanz=0;

	for (int i = 0; i<258; i++) {		
		if (data.specialSymbolCount[i]>0){
			data.specialSymbolProbability[i]=data.specialSymbolCount[i]/(data.symbolCount);	/* Bestimmt die Wahrscheinlichkeit aller Symbole */
			data.specialSymbolInformation[i]=log(1/data.specialSymbolProbability[i])/(log(2));		/* Bestimmt den Informationsgehalt eines jeden Symbols */
			data.specialSymbolEntropie[i]=data.specialSymbolInformation[i]*data.specialSymbolProbability[i];	/* Bestimmt den Entropiebeitrag eines jeden Symbols */
		}

		data.entropie=data.entropie+data.specialSymbolEntropie[i];		/* Ermittelt die Entropie aller Symbole der Quelle */
		if (data.specialSymbolEntropie[i]!=0) data.redundanz++;				/* Zhlt die Anzahl der verschiedene Symbole */
	}


	if (data.redundanz>0) {
		data.redundanz=log(data.redundanz)/log(2);							/* Bestimmt die Redundanz */
		data.redundanz=data.redundanz-data.entropie;
	}else data.redundanz=0;
#endif
}
