// StepViewer.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Aries.h"
#include "StepViewer.h"
#include <atlbase.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <algorithm>

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CStepViewer 


CStepViewer::CStepViewer(CWnd* pParent /*=NULL*/)
	: CDialog(CStepViewer::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStepViewer)
	m_position = 0;
	m_stepNum = 0;
	//}}AFX_DATA_INIT
}


void CStepViewer::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStepViewer)
	DDX_Control(pDX, IDC_SCROLLBAR1, m_scrollBar);
	DDX_Control(pDX, IDC_ARIESSTEPVIEWCTRL1, m_stepView);
	DDX_OCShort(pDX, IDC_ARIESSTEPVIEWCTRL1, DISPID(1), m_position);
	DDX_OCShortRO(pDX, IDC_ARIESSTEPVIEWCTRL1, DISPID(3), m_stepNum);
	//}}AFX_DATA_MAP
	CDialog::DoDataExchange(pDX);

}


BEGIN_MESSAGE_MAP(CStepViewer, CDialog)
	//{{AFX_MSG_MAP(CStepViewer)
	ON_WM_SIZE()
	ON_WM_SHOWWINDOW()
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CStepViewer 

void CStepViewer::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);

	if(::IsWindow(m_stepView.m_hWnd)&&::IsWindow(m_scrollBar.m_hWnd)){
		CRect scrollBarBounds;
		m_scrollBar.GetClientRect(scrollBarBounds);
		m_stepView.SetWindowPos(this,0,0,cx,cy-scrollBarBounds.Height(),SWP_NOMOVE);
		m_scrollBar.SetWindowPos(this,0,cy-scrollBarBounds.Height(),cx,scrollBarBounds.Height(),SWP_NOZORDER);
		
	}

	
}


class CStepViewer::StepAdderFunction{
private:
	CAriesStepView *stepView;
public:
	StepAdderFunction(CAriesStepView* v){stepView = v;}
	void operator()(CAritStep* s){
		stepView->addStep(s->toString());
	}	

};

void CStepViewer::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	if(bShow){
		m_stepView.clearAll();
		for_each(m_steps->begin(),m_steps->end(),
			StepAdderFunction(&m_stepView));
		int upperRange = m_stepView.GetStepNum()-1;
		m_scrollBar.SetScrollRange(0,(upperRange>0)?upperRange:32767);

	}
	
}



void CStepViewer::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);

	if(pScrollBar != &m_scrollBar)
		return;

	int scrollPos = pScrollBar->GetScrollPos();

	switch(nSBCode){
	case SB_LINELEFT:
		scrollPos--;
		break;
	case SB_PAGERIGHT:{
		CRect rc;
		m_stepView.GetClientRect(rc);
		int d = rc.Width()/m_stepView.GetStepWidth()/3;
		scrollPos += d;
		break;
					 }
	case SB_RIGHT:
		scrollPos = pScrollBar->GetScrollLimit();
		break;
	case SB_LINERIGHT:
		scrollPos++;
		break;
	case SB_PAGELEFT:{
		CRect rc;
		m_stepView.GetClientRect(rc);
		scrollPos-=rc.Width()/m_stepView.GetStepWidth()/3;
		break;
					 }
	case SB_LEFT:
		scrollPos = 0;
		break;
	case SB_THUMBPOSITION:
		scrollPos = nPos;
		break;
	case SB_THUMBTRACK:
		scrollPos = nPos;
		break;
	}

	pScrollBar->SetScrollPos(scrollPos);
	m_stepView.SetPosition(scrollPos);


}

