/* MAIN PROGRAM FOR DECODING. */

#include <stdio.h>
#include "model.h"
#include "FileParams.h"

void parseCommandLine(int argc, char *argv[]);
void openFiles();
void closeFiles();

FileParams fPar;

int main(int argc, char *argv[])
{   
	
	parseCommandLine(argc, argv);
	openFiles();

	start_model();				/* Set up other modules.    */
    start_inputing_bits();
    start_decoding();
    for (;;) {					/* Loop through characters. */
        int ch; int symbol;
        symbol = decode_symbol(cum_freq);	/* Decode next symbol.      */
//        if (symbol==EOF_symbol) break;		/* Exit loop if EOF symbol. */
        if (feof(fPar.srcFile)) break;		/* Exit loop if EOF symbol. */
        ch = index_to_char[symbol];		/* Translate to a character.*/
        fputc(ch,fPar.dstFile);			/* Write that character.    */
//        putc(ch,stdout);			/* Write that character.    */
        update_model(symbol);			/* Update the model.        */
    }

	closeFiles();
    return 0;
}

void parseCommandLine(int argc, char *argv[], FileParams *p){
	if(argc!=3){
		printf("Usage: decode <sourcefile> <destinationfile>\n");
		exit(-1);
	}

	fPar.srcName = argv[1];
	fPar.dstName = argv[2];


	printf("Inflating %s to %s\n",fPar.srcName , fPar.dstName);

}

void openFiles(){
	fPar.srcFile = fopen(fPar.srcName, "rb");
	if(fPar.srcFile==NULL){
		printf("Error opening $s\n",fPar.srcName);
		exit(-1);
	}

	fPar.dstFile = fopen(fPar.dstName, "wb");
	if(fPar.dstFile==NULL){
		printf("Error opening $s\n",fPar.dstName);
		exit(-1);
	}
}

void closeFiles(){
	fclose(fPar.srcFile);
	fclose(fPar.dstFile);
}