/* MAIN PROGRAM FOR ENCODING. */

#include <stdio.h>
#include <string.h>
#include "model.h"


void parseCommandLine(int argc, char *argv[]);
void openFiles();
void closeFiles();

int main( int argc, char *argv[ ])
{
	parseCommandLine(argc,argv);
	openFiles();

	
	start_model();				/* Set up other modules.    */
    start_outputing_bits();
    start_encoding();

    for (;;) {					/* Loop through characters. */
        int ch; int symbol;

        ch = fgetc(fPar.srcFile );			/* Read the next character. */
//        ch = getc(stdin);			/* Read the next character. */
        if (feof(fPar.srcFile)){
			break;			/* Exit loop on end-of-file.*/
		}
//        if (ch==EOF) break;			/* Exit loop on end-of-file.*/
        symbol = char_to_index[ch];		/* Translate to an index.   */
        encode_symbol(symbol,cum_freq);		/* Encode that symbol.      */
        update_model(symbol);			/* Update the model.        */
    }
    encode_symbol(EOF_symbol,cum_freq);		/* Encode the EOF symbol.   */
    done_encoding();				/* Send the last few bits.  */
    done_outputing_bits();

	closeFiles();

    return 0;
}


void parseCommandLine(int argc, char *argv[], FileParams *p){
	if(argc!=3){
		printf("Usage: encode <sourcefile> <destinationfile>\n");
		exit(-1);
	}

	fPar.srcName = argv[1];
	fPar.dstName = argv[2];


	printf("Deflating %s to %s\n",fPar.srcName , fPar.dstName);

}

void openFiles(){
	fPar.srcFile = fopen(fPar.srcName, "rb");
	if(fPar.srcFile==NULL){
		printf("Error opening $s\n",fPar.srcName);
		exit(-1);
	}

	fPar.dstFile = fopen(fPar.dstName, "wb");
	if(fPar.dstFile==NULL){
		printf("Error opening $s\n",fPar.dstName);
		exit(-1);
	}
}

void closeFiles(){
	fclose(fPar.srcFile);
	fclose(fPar.dstFile);
}
